/*
 *  Author     : Arne Vajhj
 *
 *  Programmed : february 1996
 *
 *  Purpose    : Server DECnet interface to QI-server
 *
 */
#include <string.h>
#include <time.h>
#include <stdlib.h>
#include <stdio.h>
#include <descrip.h>

#include "net.h"

long lib$wait();

typedef struct {
   struct dsc$descriptor_a a;
   struct {
      struct dsc$descriptor_d *dsc$a_a0;
      long dsc$l_m;
   } m;
   struct {
      long dsc$l_l;
      long dsc$l_u;
   } b;
} array;

extern qi_command(void **, struct dsc$descriptor_s *, array **);

main()
{
   FILE *fp;
   char *cp,cmd[100],tmp[100];
   void *ctx = NULL;
   array *result = NULL;
   int i,status;
   float f = 1.0;
   time_t t;
   struct dsc$descriptor_s cmd_dsc = {0, DSC$K_DTYPE_T, DSC$K_CLASS_S, 0};
   net_open();
   i = net_read(cmd,sizeof(cmd));
   cmd[i] = '\0';
   if (cp = strchr(cmd, '\n')) *cp = '\0';
   fp=fopen("DNQI.LOG","a");
   t = time(NULL);
   strcpy(tmp,ctime(&t));
   tmp[strlen(tmp)-1] = '\0';
   fprintf(fp,"%s %s Cmd: %s\n",tmp,getenv("SYS$NET"),cmd);
   fclose(fp);
   cmd_dsc.dsc$w_length = (short) strlen(cmd);
   cmd_dsc.dsc$a_pointer = cmd;
   status = qi_command(&ctx, &cmd_dsc, &result);
   for(i=0;i<result->m.dsc$l_m;i++)
      net_write(result->m.dsc$a_a0[i].dsc$a_pointer);
   net_write("\xFF");
   lib$wait(&f);
   net_close();
}
